---
id: 587d78af367417b2b2512b03
title: Build a Survey Form
challengeType: 3
forumTopicId: 301145
dashedName: build-a-survey-form
---

# --description--

**Objective:** Build a [CodePen.io](https://codepen.io) app that is functionally similar to this: <https://codepen.io/freeCodeCamp/full/VPaoNP>.

Fulfill the below [user stories](https://en.wikipedia.org/wiki/User_story) and get all of the tests to pass. Give it your own personal style.

You can use HTML, JavaScript, and CSS to complete this project. Plain CSS is recommended because that is what the lessons have covered so far and you should get some practice with plain CSS. You can use Bootstrap or SASS if you choose. Additional technologies (just for example jQuery, React, Angular, or Vue) are not recommended for this project, and using them is at your own risk. Other projects will give you a chance to work with different technology stacks like React. We will accept and try to fix all issue reports that use the suggested technology stack for this project. Happy coding!

**User Story #1:** I can see a title with `id="title"` in H1 sized text.

**User Story #2:** I can see a short explanation with `id="description"` in P sized text.

**User Story #3:** I can see a `form` with `id="survey-form"`.

**User Story #4:** Inside the form element, I am required to enter my name in a field with `id="name"`.

**User Story #5:** Inside the form element, I am required to enter an email in a field with `id="email"`.

**User Story #6:** If I enter an email that is not formatted correctly, I will see an HTML5 validation error.

**User Story #7:** Inside the form, I can enter a number in a field with `id="number"`.

**User Story #8:** If I enter non-numbers in the number input, I will see an HTML5 validation error.

**User Story #9:** If I enter numbers outside the range of the number input, which are defined by the `min` and `max` attributes, I will see an HTML5 validation error.

**User Story #10:** For the name, email, and number input fields inside the form I can see corresponding labels that describe the purpose of each field with the following ids: `id="name-label"`, `id="email-label"`, and `id="number-label"`.

**User Story #11:** For the name, email, and number input fields, I can see placeholder text that gives me a description or instructions for each field.

**User Story #12:** Inside the form element, I can select an option from a dropdown that has a corresponding `id="dropdown"`.

**User Story #13:** Inside the form element, I can select a field from one or more groups of radio buttons. Each group should be grouped using the `name` attribute.

**User Story #14:** Inside the form element, I can select several fields from a series of checkboxes, each of which must have a `value` attribute.

**User Story #15:** Inside the form element, I am presented with a `textarea` at the end for additional comments.

**User Story #16:** Inside the form element, I am presented with a button with `id="submit"` to submit all my inputs.

You can build your project by <a href='https://codepen.io/pen?template=MJjpwO' target='_blank' rel='nofollow'>using this CodePen template</a> and clicking `Save` to create your own pen. Or you can use this CDN link to run the tests in any environment you like: `https://cdn.freecodecamp.org/testable-projects-fcc/v1/bundle.js`

Once you're done, submit the URL to your working project with all its tests passing.

# --solutions--

```html
// solution required
```
