---
id: 5a661e0f1068aca922b3ef17
title: Використання дужок для доступу до вмісту масиву
challengeType: 1
forumTopicId: 301149
dashedName: access-an-arrays-contents-using-bracket-notation
---

# --description--

Фундаментальною особливістю будь-якої структури даних, звичайно ж, є можливість не тільки зберігати дані, але і мати можливість отримувати ці дані по команді. Отже, тепер, коли ми дізналися, як створити масив, давайте подумаєте над тим, як ми можемо отримати доступ до інформації цього масиву.

Коли ми визначаємо простий масив як показано нижче, в ньому є 3 елементи:

```js
let ourArray = ["a", "b", "c"];
```

У масиві кожен елемент масиву має <dfn>індекс</dfn>. Цей індекс подвоюється як позиція цього елемента в масиві і як ви на нього посилаєтесь. Проте важливо зазначити, що масиви JavaScript мають <dfn>нульовий індекс</dfn>це означає, що перший елемент масиву фактично знаходиться в ***нульовій*** позиції, а не в першій. Щоб отримати елемент з масиву, ми можемо помістити індекс в дужки і додати його в кінець масиву або, що відбувається частіше, до змінної, яка посилається на об'єкт масиву. Такий спосіб називають <dfn>дужки</dfn>. Наприклад, якщо ми хочемо отримати `a` з `ourArray` та призначити йому змінну, ми можемо зробити це за допомогою наступного коду:

```js
let ourVariable = ourArray[0];
```

Тепер `ourVariable` має значення `a`.

Крім доступу до значення, пов'язаного з індексом, ви також можете* встановити *індекс для значення, використовуючи таке ж позначення:

```js
ourArray[1] = "not b anymore";
```

Використовуючи дужки, ми скинули елемент з індексом 1 з рядка `b`, на `not b anymore`. Тепер `ourArray` це `["a", "not b anymore", "c"]`.

# --instructions--

Щоб виконати це завдання, встановіть другу позицію (index `1`) для `myArray` на все, що захочете, крім букви `b`.

# --hints--

`myArray[0]` повинен дорівнювати букві `a`

```js
assert.strictEqual(myArray[0], 'a');
```

`myArray[1]` не повинен дорівнювати букві `b`

```js
assert.notStrictEqual(myArray[1], 'b');
```

`myArray[2]` повинен дорівнювати букві `c`

```js
assert.strictEqual(myArray[2], 'c');
```

`myArray[3]` повинен дорівнювати букві `d`

```js
assert.strictEqual(myArray[3], 'd');
```

# --seed--

## --seed-contents--

```js
let myArray = ["a", "b", "c", "d"];
// Only change code below this line

// Only change code above this line
console.log(myArray);
```

# --solutions--

```js
let myArray = ["a", "b", "c", "d"];
myArray[1] = "e";
```
