### Soy nuevo en GitHub y Open Source. ¿Dónde debo empezar?

Lee nuestra ["Guía de como contribuir a Open Source"](https://github.com/freeCodeCamp/how-to-contribute-to-open-source). Es una referencia completa para proyectos aptos para principiantes. E incluye muchos consejos de contribución de código abierto.

### What do I need to know to contribute to the codebase?

freeCodeCamp runs on a modern JavaScript stack. If you're interested in contributing to our codebase, you will need some familiarity with JavaScript and some of the technologies we use like Node.js, MongoDB, OAuth 2.0, React, Gatsby, and Webpack.

### Can I translate freeCodeCamp's resources?

Yes - You can contribute to any of the 30+ languages we have enabled on our translation platform.

We have user-contributed translations live in some languages. We intend to localize freeCodeCamp into several major world languages. You can read all about this in our [announcement here](https://www.freecodecamp.org/news/world-language-translation-effort).

If you are interested in contributing to translations please makes sure you [read this guide](how-to-translate-files.md) first.

### Can I contribute articles to freeCodeCamp News or videos to freeCodeCamp's YouTube channel?

Yes - you can contribute to our publication blog and YouTube channel.

If you're interested in writing articles for freeCodeCamp News, please visit this [publication guide](https://www.freecodecamp.org/news/how-to-write-for-freecodecamp/). In addition, please read our [style guide](https://www.freecodecamp.org/news/developer-news-style-guide/) as this will help you write stronger and more effective articles.

To help us make educational videos for our YouTube channel, you can follow the [YouTube channel guide here](https://www.freecodecamp.org/news/how-to-contribute-to-the-freecodecamp-community-youtube-channel-b86bce4c865/).

### How can I report a new bug?

If you think you've found a bug, first read the ["Help I've Found a Bug"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) article and follow its instructions.

If you're confident it's a new bug, go ahead and create a new GitHub issue. Be sure to include as much information as possible so that we can reproduce the bug. We have a pre-defined issue template to help you through this.

Please note that these GitHub issues are for codebase-related issues and discussions – not for getting help with learning to code. Whenever in doubt, you should [seek assistance on the forum](https://forum.freecodecamp.org) before creating a GitHub issue.

### How can I report a security issue?

Please don't create GitHub issues for security issues. Instead, please send an email to `security@freecodecamp.org` and we'll look into it immediately.

### I am a student. Can I work on a feature for academic credits?

Yes. Please note we are unable to commit to any timelines or paperwork that may be a requirement by your college or university. We receive many pull-requests and code contributions from volunteer developers, and we respect their time and efforts. Out of respect for all of our other contributors, we will not give any PR special priority just because it happens to be school-related.

We request you to plan ahead and work on code contributions with this in mind.

### What do these different labels that are tagged on issues mean?

The code maintainers [triage](https://en.wikipedia.org/wiki/Software_bug#Bug_management) issues and pull requests based on their priority, severity, and other factors. You can [find a complete glossary of their meanings here](https://github.com/freecodecamp/freecodecamp/labels).

### Where do I start if I want to work on an issue?

You should go through [**`help wanted`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22help+wanted%22) or [**`first timers only`**](https://github.com/freeCodeCamp/freeCodeCamp/issues?q=is%3Aopen+is%3Aissue+label%3A%22first+timers+only%22) issues for a quick overview of what is available for you to work on.

> [!TIP] Los temas de **`se busca ayuda`** están en marcha y no es necesario pedir permiso antes de trabajar en ellos. Sin embargo, temas con la etiqueta **`solo principiantes`** son temas especiales que están diseñados para personas que no han contribuido a la base de código de freeCodeCamp antes.

### I found a typo. Should I report an issue before I can make a pull request?

For typos and other wording changes, you can directly open pull requests without creating an issue first. Please be sure to mention details in the pull request description to help us understand and review your contribution – even if it's just a minor change.

Please do create an issue if you want to discuss bigger aspects of the codebase or curriculum.

### How can I get an issue assigned to me?

We typically do not assign issues to anyone other than long-time contributors. Instead, we follow the below policy to be fair to everyone:

1. Lo más probable es que fusionemos el primer pull request que aborde el tema o problema.
2. En el caso de múltiples colaboradores abriendo un pull request para el mismo problema más o menos al mismo tiempo, daremos prioridad al pull request que aborde mejor la cuestión. Algunas de las cosas que consideramos:
   - ¿Has incluido pruebas?
   - ¿Has detectado todos los casos de usos?
   - ¿Te aseguraste de que pasaran todas las pruebas, y confirmaste que todo funciona localmente?
3. Por último, damos prioridad a los pull requests que siguen nuestras directrices recomendadas.
   - ¿Has seguido la lista de verificación de pull request?
   - ¿Has dado a tu pull request un título significativo?

### I am stuck on something that is not included in this documentation.

**Feel free to ask for help in:**

- La categoría de `Colaboradores` de [nuestro foro de la comunidad](https://forum.freecodecamp.org/c/contributors).
- El canal `#Contributors` en [nuestro servidor de chat](https://chat.freecodecamp.org/channel/contributors).

We are excited to help you contribute to any of the topics that you would like to work on. If you ask us questions on the related issue threads, we will be glad to clarify. Be sure to search for your question before posting a new one.

Thanks in advance for being polite and patient. Remember – this community is run mainly by volunteers.

### Additional Assistance

If you have queries about the stack, architecture of the codebase, translations, or anything else feel free to reach out to our staff team [on the forum](https://forum.freecodecamp.org/g/team).

**You can email our developer staff at: `dev[at]freecodecamp.org`**
